#if !defined(AFX_MAXMAXDLG_H__4BC8F186_C516_11D3_813F_000000000000__INCLUDED_)
#define AFX_MAXMAXDLG_H__4BC8F186_C516_11D3_813F_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// MaxMaxDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMaxMaxDlg dialog

#include	"cdxCDynamicDialog.h"

class CMaxMaxDlg : public cdxCDynamicDialog
{
// Construction
public:
	CMaxMaxDlg(CWnd* pParent = NULL);   // standard constructor

public:
	struct MaxMax { MaxMax(int _x=0, int _y=0) { x = _x; y = _y; } int x, y; };
	
	private:
		CMap<HWND,HWND,MaxMax,const MaxMax &>
			m_MaxMax;
		
protected:
	bool MakeMaxControl(UINT id, const MaxMax & m, bool bReposNow = true) { return MakeMaxControl(GetSafeChildHWND(id),m,bReposNow); }
	bool MakeMaxControl(HWND hwnd, const MaxMax & m, bool bReposNow = true)
	{
		// normal functionality
		
		m_MaxMax.SetAt(hwnd,m);        // remember max
		if(bReposNow)
			UpdateControlPosition(hwnd);
		return true;
	}
		
	virtual void DoDestroyCtrl(HWND hwnd)
	{
		cdxCDynamicDialog::DoDestroyCtrl(hwnd);
		m_MaxMax.RemoveKey(hwnd);
	}

	virtual bool DoMoveCtrl(HWND hwnd, UINT id, CRect & rectNewPos, const cdxCDynamicLayoutInfo & li)
	{
		if(!cdxCDynamicDialog::DoMoveCtrl(hwnd,id,rectNewPos,li))
			return false;
		
		MaxMax m;
		
		if(m_MaxMax.Lookup(hwnd,m))
		{
			if(rectNewPos.Width() > m.x)
				rectNewPos.right = rectNewPos.left + m.x;
			if(rectNewPos.Height() > m.y)
				rectNewPos.bottom = rectNewPos.top + m.y;
			
			// this is example code only; you can implement a more sophisticated logic
		}

		return true;
	}

	// Dialog Data
	//{{AFX_DATA(CMaxMaxDlg)
	enum { IDD = IDD_MAXMAX };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMaxMaxDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMaxMaxDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAXMAXDLG_H__4BC8F186_C516_11D3_813F_000000000000__INCLUDED_)
